﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.WinForms;
using ThinkGeo.MapSuite.Shapes;

namespace _9016
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                Proj4Projection _proj = new Proj4Projection();
                _proj.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                _proj.ExternalProjectionParametersString = Proj4Projection.GetEsriParametersString(54004);
                _proj.Open();

                winformsMap1.MapUnit = _proj.GetExternalGeographyUnit();

                LayerOverlay layerOverlay = new LayerOverlay();
                ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
                shapeFileLayer.FeatureSource.Projection = _proj;
                shapeFileLayer.WrappingMode = WrappingMode.WrapDateline;
                shapeFileLayer.WrappingExtent = _proj.ConvertToExternalProjection(new ThinkGeo.MapSuite.Shapes.RectangleShape(-180, 90, 180, -90));
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColors.Transparent), new GeoSolidBrush(new GeoColor(155, GeoColors.Blue)));
                shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                layerOverlay.Layers.Add(shapeFileLayer);
                winformsMap1.Overlays.Add(layerOverlay);

                LineStyle customDashLineStyle = LineStyles.CreateSimpleLineStyle(GeoColors.Gray, 1, LineDashStyle.Custom, true);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);
                customDashLineStyle.CenterPen.DashPattern.Add(4f);

                GraticuleFeatureLayer g = new GraticuleFeatureLayer(_proj);
                g.WrappingMode = WrappingMode.WrapDateline;
                g.WrappingExtent = _proj.ConvertToExternalProjection(new ThinkGeo.MapSuite.Shapes.RectangleShape(-180, 90, 180, -90));
                g.GraticuleLineStyle = customDashLineStyle;
                layerOverlay.Layers.Add("GraticuleAdornmentLayer", g);

                shapeFileLayer.Open();
                winformsMap1.CurrentExtent = shapeFileLayer.GetBoundingBox();
                winformsMap1.Refresh();
            }
            catch
            {
            }
        }
    }
}
